if(isFile("Add-Ons/System_ReturnToBlockland/server.cs")) {
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	RTB_registerPref("Outside Minigame Trust Level", "Football", "Football::minTrustLevel", "list NONE 0 BUILD 1 FULL 2 SELF 3", "Item_Football", 2, false, false);
} else
	$Football::minTrustLevel = 2;

datablock projectileData(footballProjectile) {
	projectileShapeName = "./footballprojectile.dts";
	isBallistic = true;
	muzzleVelocity = 25;
	velInheritFactor = 1;
	gravityMod = 1;
	uiName = "Football";
};

datablock ItemData(footballItem) {
	category = "Weapon";
	className = "Weapon";
	shapeFile = "./football.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 1;
	emap = true;
	uiName = "Football";
	iconName = "./icon_football";
	doColorShift = false;
	image = footballImage;
	canDrop = false;
};

datablock ShapeBaseImageData(footballImage) {
	className = "WeaponImage";
	shapeFile = "./football.dts";
	emap = true;
	mountPoint = 0;
	correctMuzzleVector = true;
	item = footballItem;
	projectile = footballProjectile;
	projectileType = projectile;
	melee = false;
	doColorShift = false;

	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]			= weaponSwitchSound;
	stateAllowImageChange[0]	= false;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= false;

	stateName[2]			= "Charge";
	stateTransitionOnTimeout[2]	= "Armed";
	stateTimeoutValue[2]		= 1;
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";
	stateScript[2]			= "onCharge";
	stateAllowImageChange[2]	= false;

	stateName[3]			= "AbortCharge";
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 0.3;
	stateWaitForTimeout[3]		= true;
	stateScript[3]			= "onAbortCharge";
	stateAllowImageChange[3]	= false;

	stateName[4]			= "Armed";
	stateTransitionOnTriggerUp[4]	= "Fire";
	stateAllowImageChange[4]	= false;

	stateName[5]			= "Fire";
	stateTransitionOnTimeout[5]	= "Ready";
	stateTimeoutValue[5]		= 0.5;
	stateFire[5]			= true;
	stateSequence[5]		= "fire";
	stateScript[5]			= "onFire";
	stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= false;
	stateSound[5]			= isObject(spearFireSound) ? spearFireSound : ""; //Stuff is executed reverse-alphabetically, so if the spear is going to be executed, it will have been by now.
};

function footballImage::onMount(%this, %obj, %slot) {
	parent::onMount(%this, %obj, %slot);
	//Stupid hack to play armReadyRight whenever this image is mounted.
	//Simply setting armReady in the image datablock is not enough,
	//because that way, ::armReady() is only called from inventory stuff
	//and we force mount this image when a football hits you and when you
	//use any tool thinking you can get out of "football thinkfast mode".
	%obj.playThread(1, armReadyRight);
}

function footballImage::onCharge(%this, %obj) {
	%obj.playthread(2, spearReady);
}

function footballImage::onAbortCharge(%this, %obj) {
	%obj.playthread(2, root);
}

function footballImage::onFire(%this, %obj, %slot) {
	%obj.playthread(1, root);
	%obj.playthread(2, spearThrow);
	if(isObject(%obj.tool[%i]) ? %obj.tool[%i].getID() == footballItem.getID() : false)
		messageClient(%obj.client, 'MsgItemPickup', '', %obj.currTool, %obj.tool[%obj.currTool] = 0);
	else for(%i = 0; %i < %obj.getDataBlock().maxTools; %i++)
		if(isObject(%obj.tool[%i]) ? %obj.tool[%i].getID() == footballItem.getID() : false) {
			messageClient(%obj.client, 'MsgItemPickup', "", %i, %obj.tool[%i] = 0);
			break;
		}
	%obj.unMountImage(%slot);
	parent::onFire(%this, %obj, %slot);
}

function footballProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal) {
	if(isObject(%obj.sourceObject) && %col.getType() & $typemasks::playerObjectType && (miniGameCanDamage(%col, %obj.sourceObject) == 1 || getTrustLevel(%obj.client, %col.client) >= $Football::minTrustLevel))
		%col.mountImage(footballImage, footballImage.mountPoint);
	else {
		%datablock = footballItem;
		%normScale = vectorScale(%normal, %datablock.elasticity);
		%item = new Item() {
			dataBlock = %datablock;
			position = vectorAdd(%pos, %normScale);
			rotate = true;
			client = %obj.client;
			isFumble = true;
		};
		%item.setVelocity(%normScale);
		%item.schedulePop();
		missionCleanup.add(%item);
	}
}

package Item_Football {
	function serverCmdUseTool(%client, %invSlot) {
		if(%client.player.pendingFootball) {
			%client.player.pendingFootball = false;
			%client.player.mountImage(footballImage, footballImage.mountPoint);
			return;
		} else if(isObject(%client.player))
			if(isObject(%client.player.tool[%client.player.currtool]) && isObject(%mountedImage = %client.player.getMountedImage(footballImage.mountPoint)))
				if(%client.player.tool[%client.player.currtool].getID() == footballItem.getID() && %mountedImage.getID() == footballImage.getID()) //not just using .getMountedImage().getid() because if they don't have anything mounted, it causes console spam.
					%client.player.unMountImage(footballImage.mountPoint);
		return parent::serverCmdUseTool(%client, %invSlot);
	}

	function serverCmdUnUseTool(%client) {
		if(isObject(%client.player))
			if(isObject(%mountedImage = %client.player.getMountedImage(footballImage.mountPoint)))
				if(%mountedImage.getID() == footballImage.getID())
					%client.player.pendingFootball = true;
		return parent::serverCmdUnUseTool(%client);
	}

	function footballItem::onPickup(%this, %obj, %col) {
		if(%obj.isFumble)
			return false;
		return parent::onPickup(%this, %obj, %col);
	}
};
activatePackage(Item_Football);
